include:
  - template: Terraform.latest.gitlab-ci.yml

.secrets:
  secrets:
    AWS_ACCESS_KEY_ID:
      vault: infrastructure/aws/AWS_ACCESS_KEY_ID@secret
      file: false
    AWS_SECRET_ACCESS_KEY:
      vault: infrastructure/aws/AWS_SECRET_ACCESS_KEY@secret
      file: false
    AWS_REGION:
      vault: infrastructure/aws/AWS_REGION@secret
      file: false
    GITLAB_TOKEN:
      vault: infrastructure/gitlab/GITLAB_TOKEN@secret
      file: false

stages:
  - validate
  - test
  - build
  - deploy
  - cleanup

variables:
  TF_IN_AUTOMATION: "true"
  TF_STATE_NAME: production
  TF_CACHE_KEY: default

vault ping:
  image:
    name: hashicorp/vault:latest
    entrypoint:
        - '/usr/bin/env'
        - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
  stage: .pre
  script:
    - echo "Check status of $VAULT_ADDR"
    - |
      until vault status
      do
        echo "Vault returned error or sealed"
        sleep 5
      done
  rules:
    - if: '$VAULT_ADDR'
      when: always

fmt:
  allow_failure: false

build:
  extends: [.secrets, .terraform:build]

deploy:
  extends: [.secrets, .terraform:deploy]
  environment:
    name: $TF_STATE_NAME

destroy:
  extends: [.secrets, .terraform:destroy]
  needs: []
  environment:
    name: $TF_STATE_NAME
    action: stop

